import time, localisation, fourG, os, threading, random, sys, tty, termios
from math import *
R = 6371000
MAIN = 0
class Testor(object):
    def __init__(self, fake4g = False, fake_gps = False, distance = 10, 
refresh_time = 1, save_data = True):
        
        if not fake4g :
            self.dongle = fourG.FourG('/dev/ttyUSB2')

        self.signal = 0
        self.min_dist = distance
        self.display = True        
                
        if not fake_gps :
            self.loc = localisation.Gps()
            self.old_lat, self.old_lon = self.loc.getPos()
        else :
            self.old_lat, self.old_lon = 0,0
        
        if save_data:
            self.enableDataSave()
        
        self.fake4g = fake4g
        self.fake_gps = fake_gps
        self.save_data = save_data
        self.refresh_time = refresh_time
        self.keep_update = False
        self.keep = True
        self.display_menu = MAIN


    def updateLoop(self):
        self.keep_update = True
        
        while self.keep_update:
        
            if not self.fake_gps :
                self.lat, self.lon = self.loc.getPos()

            else:
                self.lat, self.lon = random.randrange(360),random.randrange(360)

            distance=R*2*asin(sqrt((sin((radians(self.lat)-radians(self.old_lat))/2))**2 +cos(radians(self.lat))*cos(radians(self.old_lat))*(sin((radians(self.lon)-radians(self.old_lon))/2))**2))
            
            if self.fake_gps or distance >= self.min_dist:
                self.old_lat, self.old_lon = self.lat, self.lon
                if not self.fake4g: self.signal = self.dongle.getSignal()
                if self.signal == "99" : self.signal = "-1"

                if self.signal!='ERROR' and self.save_data:
                    self.saveData()
                    
            time.sleep(self.refresh_time)
            
            
    def displayLoop(self):
    
        while self.display:
        
            os.system("clear")
            
            if self.display_menu == MAIN:
                print "4G Analyser\n\n"
                print "Lat/Lon\t\t"+str(self.lat)+"/"+str(self.lon)
                print "Signal\t\t"+str(self.signal)
                print "Point number\t\t"+str(self.id)
                
            elif self.display_menu == CONF:
                if self.fake4G: print "Fake 4G\t\tON"
                else: print "Fake 4G\t\tOFF"
                if self.fake_gps: print "Fake GPS\t\tON"
                else: print "Fake GPS\t\tOFF"
                print "Minimal disantce\t\t"+str(self.min_dist)
                print "Refresh time\t\t"+str(self.refesh_time)
                if self.save_data:print "Save data\t\tON"
                else : print "Save data OFF\t\t"
            time.sleep(0.1)
                
    def eventLoop(self):
        while self.keep:
            ch = sys.stdin.read(1)
            if ch == "q":
                self.display = False
                self.keep_update = False
                self.keep = False
    
                
    def enableDataSave(self):
        if not os.path.isfile("data.csv"):
            with(open("data.csv","a")) as file:
                    file.write("id,lat,long,signal,date\n")
        with(open("data.csv","r")) as file:
            lines = file.readlines()
            self.id = len(lines)

    def saveData(self):
        with(open("data.csv","a")) as file:
            file.write(str(self.id)+","+str(self.lat)+","+str(self.lon)+","+str(self.signal)+","+str(time.strftime('%d/%m/%y %H:%M',time.localtime()))+"\n")
            self.id += 1
            
    
